% Reads a 2dseq-file from Bruker Biospec. 
% Argument: rawRead('filename', size_x, size_y, size_z) 
% Example: rawRead('2dseq', 256,256,128) 
%
% Author: Torgil Rise, 09.des 2003
% Updated: 12.des 2003

function A = rawRead(fname,nx,ny,nz)
% input arguments 
%   fname    : filename of file to be read
%   sz       : 1x3 vector containing nx x ny x nz

fid=fopen(fname,'rb','n');
A=zeros(nx,ny,nz);
if fid>=0
   for i=1:nz,
       A(:,:,i)=fread(fid,[nx ny],'uchar');
%	   i
   end
   fclose(fid);
else
   %load train; sound(y);
   disp('       ** File could not be opened **');
   disp('   Check file name entry and current directory');
   A=[];
end;

