% From "MATLAB array manipulation tips and tricks"
% http://home.online.no/~pjacklam/matlab/doc/mtt/doc/mtt.pdf
%
% Peter J. Acklam
% E-mail: pjacklam@online.no
% URL: http://home.online.no/~pjacklam
% 18th October 2003

%function Z = rot903d(X, dim1, dim2)
function Z = rot903d(X, dim)

% Largest dimension number we have to deal with.
%nd = max( [ ndims(X) dim1 dim2 ] );

% Initialize subscript cell array.
%v = repmat({':'}, [nd 1]);

% Rotate 90 degrees counterclockwise

% (reverse dim2)
%v{dim2} = size(X,dim2):-1:1;
%Y = X(v{:});

% (swap dim1 with dim2)
%d = 1:nd;
%d([ dim1 dim2 ]) = [ dim2 dim1 ];
%Z = permute(Y, d);

s = size(X); % size vector

% determine dimension permutation vector
v = [ 1 2 3];
X2 = X;
switch dim
    case 1
        % dimension 1 is constant, 2 and 3 swapped
        v = [ 1 3 2 ];
        % dimension 3 is reversed (CCW)
        X2 = X(:,:,s(3):-1:1);
    case 2
        % dimension 2 is constant, 1 and 3 swapped
        v = [ 3 2 1 ];
        % dimension 1 is reversed (CCW)
        X2 = X(s(1):-1:1,:,:);
    case 3
        % dimension 3 is constant, 1 and 2 swapped
        v = [ 2 1 3 ];
        % dimension 2 is reversed (CCW)
        X2 = X(:,s(2):-1:1,:);
end
Y = permute( X2, v );
Z = reshape( Y, s(v) );